diff --git a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
index e68589a8f..ec0cb4155 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
@@ -33,6 +33,7 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.vehicle.EntityBoat;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.ChatEmotes;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.client.net.command.ClientCommandSource;
 import net.minecraft.core.player.Session;
@@ -336,7 +337,7 @@ public class PlayerLocal extends Player {
                 this.mc.thePlayer.sendMessage(TextFormatting.RED + e.getMessage());
             }
         } else {
-            this.mc.hudIngame.addChatMessage("<" + getDisplayName() + TextFormatting.RESET + "> " + TextFormatting.WHITE + s);
+            this.mc.hudIngame.addChatMessage("<" + getDisplayName() + TextFormatting.RESET + "> " + TextFormatting.WHITE + ChatEmotes.process(s));
         }
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/IntegerSliderElement.java b/game/client/src/main/java/net/minecraft/client/gui/IntegerSliderElement.java
index 950bb3256..71b58e899 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/IntegerSliderElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/IntegerSliderElement.java
@@ -60,7 +60,7 @@ public class IntegerSliderElement extends ButtonElement {
         int maxValue = this.option.size() - 1;
         if (this.dragging) {
             int segments = maxValue;
-            float percentage = (float) (mouseX - (this.xPosition + 4) - (this.width / (2 * segments))) / (float) (this.width - sliderWidth);
+            float percentage = (float)(mouseX - (this.xPosition + 4) - this.width / (this.width * maxValue)) / (float)(this.width - sliderWidth);
 
             if (percentage > 1.0f)
                 percentage = 1.0f;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatEmotePicker.java b/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatEmotePicker.java
index 7d95ca20e..58a6a410b 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatEmotePicker.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatEmotePicker.java
@@ -11,6 +11,9 @@ import java.util.Map;
 public class GuiElementChatEmotePicker extends Gui {
     private static final int CELL_WIDTH = 16;
     private static final int CELL_HEIGHT = 16;
+    private static final int SCROLLBAR_WIDTH = 2;
+    private static final int BACKGROUND_COLOR = 0xC0000000;
+    private static final int SCROLLBAR_COLOR = 0xFF808080;
 
     private final Minecraft mc;
     private final ScreenChat parent;
@@ -34,8 +37,8 @@ public class GuiElementChatEmotePicker extends Gui {
         this.height = yCells * CELL_HEIGHT;
 
         this.yCellsInner = (int) Math.ceil((double) ChatEmotes.getEmotes().size() / xCells);
-        this.heightInner = yCellsInner * CELL_HEIGHT;
-        this.maxScroll = heightInner - height;
+        this.heightInner = Math.max(yCellsInner * CELL_HEIGHT, 1);
+        this.maxScroll = Math.max(heightInner - height, 0);
 
         this.emotes = new Map.Entry[yCellsInner][xCells];
         int i = 0;
@@ -65,9 +68,19 @@ public class GuiElementChatEmotePicker extends Gui {
     }
 
     public void draw(int x, int y, int mouseX, int mouseY) {
+        draw(x, y, mouseX, mouseY, 1.0f, x, y);
+    }
+
+
+    public void draw(int x, int y, int mouseX, int mouseY, float scale, int anchorX, int anchorY) {
         drawOuter(x, y);
 
-        Scissor.enable(x, y, width, height);
+        Scissor.enable(
+            Math.round(anchorX + (x - anchorX) * scale),
+            Math.round(anchorY + (y - anchorY) * scale),
+            Math.round(width * scale),
+            Math.round(height * scale)
+        );
         drawInner(x, y, mouseX, mouseY);
         Scissor.disable();
     }
@@ -90,19 +103,21 @@ public class GuiElementChatEmotePicker extends Gui {
     }
 
     private void drawOuter(int x, int y) {
-        drawRect(x, y, x + width + 2, y + height, 0xFF000000);
+        drawRect(x, y, x + width + SCROLLBAR_WIDTH, y + height, BACKGROUND_COLOR);
 
-        // Draw scrollbar
+        // Draw scrollbar, unless everything already fits
+        if (maxScroll <= 0) return;
         int scrollbarHeight = height * height / heightInner;
         int scrollbarY = y + scroll * (height - scrollbarHeight) / maxScroll;
-        drawRect(x + width, scrollbarY, x + width + 2, scrollbarY + scrollbarHeight, 0xFF808080);
+        drawRect(x + width, scrollbarY, x + width + SCROLLBAR_WIDTH, scrollbarY + scrollbarHeight, SCROLLBAR_COLOR);
     }
 
     private void drawInner(int x, int y, int mouseX, int mouseY) {
         mouseX = mouseX - x;
         mouseY = mouseY - y;
-        int cellX = mouseX / CELL_WIDTH;
-        int cellY = (mouseY + scroll) / CELL_HEIGHT;
+        boolean mouseInside = mouseX >= 0 && mouseX < width && mouseY >= 0 && mouseY < height;
+        int cellX = mouseInside ? mouseX / CELL_WIDTH : -1;
+        int cellY = mouseInside ? (mouseY + scroll) / CELL_HEIGHT : -1;
 
         for (int cy = 0; cy < emotes.length; cy++) {
             Map.Entry<String, Character>[] row = emotes[cy];
diff --git a/game/client/src/main/java/net/minecraft/client/gui/chat/ScreenChat.java b/game/client/src/main/java/net/minecraft/client/gui/chat/ScreenChat.java
index 94e1074de..33e0470ac 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/chat/ScreenChat.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/chat/ScreenChat.java
@@ -3,6 +3,7 @@ package net.minecraft.client.gui.chat;
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.gui.Screen;
 import net.minecraft.client.gui.hud.component.ComponentAnchor;
+import net.minecraft.client.gui.hud.component.HudComponentChatInput;
 import net.minecraft.client.gui.hud.component.HudComponents;
 import net.minecraft.client.gui.keyboard.ScreenKeyboard;
 import net.minecraft.client.gui.text.TextFieldEditor;
@@ -17,6 +18,9 @@ import net.minecraft.client.gui.text.ITextField;
 import org.lwjgl.input.Mouse;
 import org.slf4j.Logger;
 
+import java.util.ArrayList;
+import java.util.List;
+
 public class ScreenChat extends Screen implements ITextField {
 	protected static final Logger LOGGER = LogUtils.getLogger();
 	public String message;
@@ -27,6 +31,7 @@ public class ScreenChat extends Screen implements ITextField {
 	protected GuiElementChatEmotePicker emotePicker;
 	protected boolean showEmotePicker = false;
 	private GuiElementChatSuggestions suggestionsElement;
+	private final List<Integer> lineStarts = new ArrayList<>();
 
 	public ScreenChat() {
 		this("");
@@ -37,6 +42,7 @@ public class ScreenChat extends Screen implements ITextField {
         this.updateCounter = 0;
         this.editor = new TextFieldEditor(this);
         this.editor.setCursor(10000);
+        this.lineStarts.add(0);
 	}
 
 	@Override
@@ -50,7 +56,7 @@ public class ScreenChat extends Screen implements ITextField {
                 this.mc,
                 this.editor,
 				this,
-				(parent, child, minecraft, followParameters) -> HudComponents.CHAT_INPUT.getLayout().getComponentX(HudComponents.CHAT_INPUT, minecraft.resolution.getScaledWidthScreenCoords()) + 14 + (followParameters ? this.suggestionsElement.getDefaultParameterPosition() - 1 : 0),
+				(parent, child, minecraft, followParameters) -> HudComponents.CHAT_INPUT.getLayout().getComponentX(HudComponents.CHAT_INPUT, minecraft.resolution.getScaledWidthScreenCoords()) + HudComponentChatInput.FIELD_X_OFFSET + (followParameters ? getFieldXOffset(MathHelper.clamp(this.suggestionsElement.getSuggestionRangeStart(), 0, this.message.length())) - 1 : 0),
 				(parent, child, minecraft, followParameters) -> HudComponents.CHAT_INPUT.getLayout().getComponentY(HudComponents.CHAT_INPUT, minecraft.resolution.getScaledHeightScreenCoords()) - 2,
 				ComponentAnchor.BOTTOM_LEFT
 			);
@@ -83,6 +89,7 @@ public class ScreenChat extends Screen implements ITextField {
 	public void removed() {
 		Keyboard.enableRepeatEvents(false);
         HudComponents.CHAT.chatScroll = 0;
+        HudComponents.CHAT_INPUT.setLineCount(1);
 	}
 
 	@Override
@@ -206,19 +213,26 @@ public class ScreenChat extends Screen implements ITextField {
 	@Override
 	public void render(int mx, int my, float partialTick) {
 		try {
-			int inputX = HudComponents.CHAT_INPUT.getLayout().getComponentX(HudComponents.CHAT_INPUT, this.width);
-			int inputY = HudComponents.CHAT_INPUT.getLayout().getComponentY(HudComponents.CHAT_INPUT, this.height);
-			float scale = HudComponents.CHAT_INPUT.getScale();
-			int boxWidth = HudComponents.CHAT_INPUT.getBaseXSize();
+			HudComponentChatInput input = HudComponents.CHAT_INPUT;
+
+			updateWrappedLines(input.getTextWrapWidth());
+			input.setLineCount(this.lineStarts.size());
+
+			int inputX = input.getLayout().getComponentX(input, this.width);
+			int inputY = input.getLayout().getComponentY(input, this.height);
+			float scale = input.getScale();
+			int boxWidth = input.getBaseXSize();
+			int boxHeight = input.getBoxHeight();
 
 			// Convert mouse coords to component-local (unscaled) space for hit-testing.
 			int localMx = unscaleX(mx, inputX, scale);
 			int localMy = unscaleY(my, inputY, scale);
 
-			// Draw emote picker button
+			// Draw emote picker button, kept level with the bottom line of the box
+			int buttonY = inputY + boxHeight - 12;
 			int emotePickerButtonColor = 0x80000000;
 			int emotePickerTextColor = 0xE0E0E0;
-			if (localMx >= inputX && localMx < inputX + 12 && localMy >= inputY && localMy < inputY + 12)
+			if (localMx >= inputX && localMx < inputX + 12 && localMy >= buttonY && localMy < buttonY + 12)
 			{
 				emotePickerButtonColor = 0x80ffffff;
 				emotePickerTextColor = 0xffffffa0;
@@ -232,27 +246,29 @@ public class ScreenChat extends Screen implements ITextField {
 				GLRenderer.modelM4f().translate(-inputX, -inputY, 0.0f);
 			}
 
-			drawRect(inputX, inputY, inputX + 12, inputY + 12, emotePickerButtonColor);
-			drawStringCenteredShadow(this.fontRenderer, Character.toString('\u263a'), inputX + 6, inputY + 2, emotePickerTextColor);
+			drawRect(inputX, buttonY, inputX + 12, buttonY + 12, emotePickerButtonColor);
+			drawStringCenteredShadow(this.fontRenderer, Character.toString('\u263a'), inputX + 6, buttonY + 2, emotePickerTextColor);
+
+			drawRect(inputX + HudComponentChatInput.FIELD_X_OFFSET, inputY, inputX + boxWidth, inputY + boxHeight, 0x80000000);
+
+			int suggestionStart = MathHelper.clamp(this.suggestionsElement.getSuggestionRangeStart(), 0, this.message.length());
+			drawStringShadow(this.fontRenderer, this.suggestionsElement.getSuggestionPreview(),
+				inputX + HudComponentChatInput.FIELD_X_OFFSET + getFieldXOffset(suggestionStart),
+				inputY + 2 + getFieldYOffset(suggestionStart), 0xFFFFFF);
 
-			drawRect(inputX + 14, inputY, inputX + boxWidth, inputY + 12, 0x80000000);
+			drawWrappedMessage(inputX, inputY);
 
-			drawStringShadow(this.fontRenderer, this.suggestionsElement.getSuggestionPreview(), inputX + 14 + this.suggestionsElement.getDefaultParameterPosition(), inputY + 2, 0xFFFFFF);
 			boolean drawCursor = (this.updateCounter / 6) % 2 == 0;
-			int cursor = this.editor.getCursor();
-			drawStringShadow(this.fontRenderer, this.suggestionsElement.colorCodeText(this.message, true), inputX + 16, inputY + 2, 0xE0E0E0);
 			if (drawCursor)
 			{
-				int width = MathHelper.ceil(this.fontRenderer.stringWidthDouble(this.message));
-				if (cursor < this.message.length())
-				{
-					width = MathHelper.ceil(this.fontRenderer.stringWidthDouble(this.message.substring(0, cursor)));
-				}
-				drawStringShadow(this.fontRenderer, "_", inputX + 16 + width, inputY + 2, 0xE0E0E0);
+				int cursor = MathHelper.clamp(this.editor.getCursor(), 0, this.message.length());
+				drawStringShadow(this.fontRenderer, "_",
+					inputX + HudComponentChatInput.FIELD_X_OFFSET + getFieldXOffset(cursor),
+					inputY + 2 + getFieldYOffset(cursor), 0xE0E0E0);
 			}
 
 			if (this.showEmotePicker) {
-                this.emotePicker.draw(inputX, inputY - 2 - this.emotePicker.getHeight(), localMx, localMy);
+                this.emotePicker.draw(inputX, inputY - 2 - this.emotePicker.getHeight(), localMx, localMy, scale, inputX, inputY);
 			}
 
 			if (scaled) {
@@ -278,19 +294,130 @@ public class ScreenChat extends Screen implements ITextField {
 		return Math.round(anchorY + (screenY - anchorY) / scale);
 	}
 
+	/**
+	 * Word wraps {@link #message} into {@link #lineStarts}. Unlike the font renderer's own splitting
+	 * this keeps indices into the original string.
+	 */
+	private void updateWrappedLines(int wrapWidth) {
+		this.lineStarts.clear();
+		this.lineStarts.add(0);
+
+		double lineWidth = 0;
+		double wordWidth = 0;
+		int wordStart = 0;
+		for (int i = 0; i < this.message.length(); i++) {
+			char c = this.message.charAt(i);
+			// format codes don't take up any space
+			if (c == '§' && i + 1 < this.message.length()) {
+				i++;
+				continue;
+			}
+
+			double charWidth = this.fontRenderer.stringWidthDouble(String.valueOf(c));
+			if (c == ' ') {
+				lineWidth += wordWidth + charWidth;
+				wordWidth = 0;
+				wordStart = i + 1;
+				continue;
+			}
+
+			if (lineWidth + wordWidth + charWidth > wrapWidth) {
+				int currentLineStart = this.lineStarts.get(this.lineStarts.size() - 1);
+				if (wordStart > currentLineStart) {
+					// Carry the whole word down to the next line
+					this.lineStarts.add(wordStart);
+					lineWidth = 0;
+				} else if (i > currentLineStart) {
+					// single word is too long, so break it midway
+					this.lineStarts.add(i);
+					wordStart = i;
+					wordWidth = 0;
+					lineWidth = 0;
+				}
+			}
+			wordWidth += charWidth;
+		}
+	}
+
+	/** Index of the wrapped line that the given index into {@link #message} sits on. */
+	private int getLineForIndex(int index) {
+		for (int i = this.lineStarts.size() - 1; i > 0; i--) {
+			if (this.lineStarts.get(i) <= index) return i;
+		}
+		return 0;
+	}
+
+	/** X offset of an index into {@link #message}, measured from the left edge of the text box. */
+	private int getFieldXOffset(int index) {
+		int lineStart = this.lineStarts.get(getLineForIndex(index));
+		return 2 + MathHelper.ceil(this.fontRenderer.stringWidthDouble(TextFieldEditor.substring(this.message, lineStart, index)));
+	}
+
+	/** Y offset of an index into {@link #message}, measured from the first line of the text box. */
+	private int getFieldYOffset(int index) {
+		return getLineForIndex(index) * HudComponentChatInput.LINE_HEIGHT;
+	}
+
+	private void drawWrappedMessage(int inputX, int inputY) {
+		String colored = this.suggestionsElement.colorCodeText(this.message, true);
+		int[] coloredIndices = mapRawIndicesToColored(colored, this.message.length());
+
+		for (int line = 0; line < this.lineStarts.size(); line++) {
+			int start = this.lineStarts.get(line);
+			int end = line + 1 < this.lineStarts.size() ? this.lineStarts.get(line + 1) : this.message.length();
+			String text = TextFieldEditor.substring(colored, coloredIndices[start], coloredIndices[end]);
+
+			drawStringShadow(this.fontRenderer, formattingAt(colored, coloredIndices[start]) + text,
+				inputX + HudComponentChatInput.FIELD_X_OFFSET + 2,
+				inputY + 2 + line * HudComponentChatInput.LINE_HEIGHT, 0xE0E0E0);
+		}
+	}
+
+	/** Maps each index of the raw message onto the matching index of its color coded form.*/
+	private static int[] mapRawIndicesToColored(String colored, int rawLength) {
+		int[] indices = new int[rawLength + 1];
+		int raw = 0;
+		int i = 0;
+		while (i < colored.length() && raw < rawLength) {
+			if (colored.charAt(i) == '§' && i + 1 < colored.length()) {
+				i += 2;
+				continue;
+			}
+			indices[raw++] = i++;
+		}
+		while (raw <= rawLength) {
+			indices[raw++] = colored.length();
+		}
+		return indices;
+	}
+
+	/** The last formatting code appearing before the given index, or an empty string if there is none. */
+	private static String formattingAt(String colored, int index) {
+		String formatting = "";
+		for (int i = 0; i + 1 < Math.min(index, colored.length()); i++) {
+			if (colored.charAt(i) == '§') {
+				formatting = colored.substring(i, i + 2);
+				i++;
+			}
+		}
+		return formatting;
+	}
+
 	@Override
 	public void mouseClicked(int mx, int my, int buttonNum) {
 		super.mouseClicked(mx, my, buttonNum);
 		try {
 			boolean handled = false;
 			if (buttonNum == 0) {
-				int inputX = HudComponents.CHAT_INPUT.getLayout().getComponentX(HudComponents.CHAT_INPUT, this.width);
-				int inputY = HudComponents.CHAT_INPUT.getLayout().getComponentY(HudComponents.CHAT_INPUT, this.height);
-				float scale = HudComponents.CHAT_INPUT.getScale();
+				HudComponentChatInput input = HudComponents.CHAT_INPUT;
+				int inputX = input.getLayout().getComponentX(input, this.width);
+				int inputY = input.getLayout().getComponentY(input, this.height);
+				float scale = input.getScale();
 				int localMx = unscaleX(mx, inputX, scale);
 				int localMy = unscaleY(my, inputY, scale);
+				int buttonY = inputY + input.getBoxHeight() - 12;
 
-				if (localMx >= inputX && localMx < inputX + 12 && localMy >= inputY && localMy < inputY + 12) {
+				if (localMx >= inputX && localMx < inputX + 12 && localMy >= buttonY && localMy < buttonY + 12) {
                     this.showEmotePicker = !this.showEmotePicker;
 					handled = true;
 				}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
index fe7d2dbb7..0fac3002c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
@@ -309,11 +309,7 @@ public abstract class ScreenContainerAbstract extends Screen {
                 }
                 Slot slot = this.inventorySlots.getSlot(getSlotId(mx, my));
                 if (slot != null) {
-                    if (slot.getItemStack() == null) {
-                        this.mc.playerController.handleInventoryMouseClick(this.inventorySlots.containerId, InventoryAction.SORT, new int[]{slot.index, 64}, this.mc.thePlayer);
-                    } else {
-                        this.mc.playerController.handleInventoryMouseClick(this.inventorySlots.containerId, InventoryAction.CREATIVE_GRAB, new int[]{slot.index, 64}, this.mc.thePlayer);
-                    }
+                    creativeGrabStack(slot);
                 }
                 return;
             }
@@ -345,6 +341,15 @@ public abstract class ScreenContainerAbstract extends Screen {
         int catalogIndex = slot instanceof SlotCreative creativeSlot ? MenuInventoryCreative.getCreativeItemIndex(creativeSlot.item) : -1;
         return new int[]{slot.index, amount, stack != null ? stack.itemID : 0, stack != null ? stack.getMetadata() : 0, catalogIndex};
     }
+    
+    protected void creativeGrabStack(@NotNull Slot slot) {
+        ItemStack stack = slot.getItemStack();
+        if (stack == null) {
+            this.mc.playerController.handleInventoryMouseClick(this.inventorySlots.containerId, InventoryAction.SORT, new int[]{slot.index, 64}, this.mc.thePlayer);
+        } else {
+            this.mc.playerController.handleInventoryMouseClick(this.inventorySlots.containerId, InventoryAction.CREATIVE_GRAB, creativeSlotArgs(slot, stack.getMaxStackSize()), this.mc.thePlayer);
+        }
+    }
 
     protected int[] hotbarSwapArgs(int slotId, int hotbarSlotNumber) {
         Slot slot = this.inventorySlots.getSlot(slotId);
@@ -354,6 +359,10 @@ public abstract class ScreenContainerAbstract extends Screen {
         return new int[]{slotId, hotbarSlotNumber};
     }
 
+    public void clickSlot(@NotNull Slot slot, int mouseButton) {
+        clickInventory(slot.x + 8 + (this.width - this.xSize) / 2, slot.y + 8 + (this.height - this.ySize) / 2, mouseButton);
+    }
+
     /**
      * This method controls what InventoryAction is sent to the server
      */
@@ -374,12 +383,7 @@ public abstract class ScreenContainerAbstract extends Screen {
         if (!this.mc.thePlayer.getGamemode().hasBlockConsumption()) {
             // Duplicate items with middle mouse button
             if (mouseButton == 2) {
-                Slot slot = this.inventorySlots.getSlot(slotId);
-                if (slot.getItemStack() == null) {
-                    this.mc.playerController.handleInventoryMouseClick(this.inventorySlots.containerId, InventoryAction.SORT, new int[]{slotId, 64}, this.mc.thePlayer);
-                } else {
-                    this.mc.playerController.handleInventoryMouseClick(this.inventorySlots.containerId, InventoryAction.CREATIVE_GRAB, new int[]{slotId, 64}, this.mc.thePlayer);
-                }
+                creativeGrabStack(this.inventorySlots.getSlot(slotId));
                 return;
             }
         }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/SlotGuidebook.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/SlotGuidebook.java
index e1bcf2f0f..188d635b1 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/SlotGuidebook.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/SlotGuidebook.java
@@ -7,6 +7,7 @@ import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.data.registry.recipe.RecipeEntryBase;
 import net.minecraft.core.data.registry.recipe.RecipeSymbol;
+import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryTrommel;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
@@ -14,6 +15,7 @@ import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.player.inventory.slot.Slot;
 import org.jetbrains.annotations.Nullable;
 
+import java.util.ArrayList;
 import java.util.List;
 import java.util.Random;
 
@@ -21,9 +23,11 @@ public class SlotGuidebook extends Slot
 {
 	public @Nullable ItemStack item;
 	public @Nullable RecipeSymbol symbol;
+	public @Nullable List<ItemStack> searchFilteredItems;
 	public @Nullable RecipeEntryBase<?,?,?> recipe;
 	public int recipeIndex = 0;
 	public int recipeAmount = 0;
+	private int cycleIndex = 0;
 	public boolean isOutput = false;
 	public SlotGuidebook(final int id, final int x, final int y, final @Nullable RecipeSymbol symbol, final boolean discovered, final @Nullable RecipeEntryBase<?,?,?> recipe)
 	{
@@ -31,7 +35,7 @@ public class SlotGuidebook extends Slot
 		this.index = id;
 		this.symbol = symbol;
 		if(symbol != null && symbol.getItemGroup() != null){
-			showRandomItem();
+			randomizeCycleStart();
 		} else if (symbol != null) {
             this.item = symbol.resolve().get(0);
 			if(recipe instanceof RecipeEntryTrommel entryTrommel){
@@ -50,7 +54,7 @@ public class SlotGuidebook extends Slot
 		super(null, id, x, y);
 		this.symbol = symbol;
 		if(symbol != null && symbol.getItemGroup() != null){
-			showRandomItem();
+			randomizeCycleStart();
 		} else if (symbol != null) {
             this.item = symbol.resolve().get(0);
 		}
@@ -104,16 +108,53 @@ public class SlotGuidebook extends Slot
 
 	public void showRandomItem(){
 		if(this.symbol != null && this.symbol.getItemGroup() != null){
-			Random r = new Random();
-			List<ItemStack> list = this.symbol.resolve();
-			ItemStack newItem = list.get(r.nextInt(list.size()));
-			if (list.size() > 1) {
-				while (newItem == this.item){
-					newItem = list.get(r.nextInt(list.size()));
-				}
+			List<ItemStack> list = this.searchFilteredItems != null ? this.searchFilteredItems : this.symbol.resolve();
+			if (list.isEmpty()) return;
+			this.cycleIndex = (this.cycleIndex + 1) % list.size();
+			this.item = list.get(this.cycleIndex);
+		}
+	}
+
+	public void randomizeCycleStart(){
+		if(this.symbol != null && this.symbol.getItemGroup() != null){
+			List<ItemStack> list = this.searchFilteredItems != null ? this.searchFilteredItems : this.symbol.resolve();
+			if (!list.isEmpty()){
+				this.cycleIndex = new Random().nextInt(list.size());
+				this.item = list.get(this.cycleIndex);
+			}
+		}
+	}
+
+	public void applySearchFilter(@Nullable SearchQuery query){
+		if(query == null || this.symbol == null || this.symbol.getItemGroup() == null) return;
+		List<ItemStack> all = this.symbol.resolve();
+		if(all == null || all.size() < 2) return;
+		List<ItemStack> matches = new ArrayList<>();
+		for(ItemStack stack : all){
+			if(itemMatchesQuery(stack, query)) matches.add(stack);
+		}
+		if(!matches.isEmpty() && matches.size() < all.size()){
+			this.searchFilteredItems = matches;
+			this.item = matches.get(0);
+		}
+	}
+
+	private static boolean itemMatchesQuery(ItemStack stack, SearchQuery query){
+		if(query.query.getLeft() == SearchQuery.QueryType.NAME){
+			String term = query.query.getRight();
+			if(term == null || term.isEmpty()) return false;
+			return query.strict
+				? stack.getDisplayName().equalsIgnoreCase(term)
+				: stack.getDisplayName().toLowerCase().contains(term.toLowerCase());
+		} else if(query.query.getLeft() == SearchQuery.QueryType.GROUP && query.query.getRight() != null && !query.query.getRight().isEmpty()){
+			try {
+				List<ItemStack> groupStacks = new RecipeSymbol(query.query.getRight()).resolve();
+				return groupStacks != null && groupStacks.contains(stack);
+			} catch (RuntimeException e){
+				return false;
 			}
-            this.item = newItem;
 		}
+		return false;
 	}
 	public boolean getIsDiscovered(Player player){
 		if (this.item == null || this.discovered) return true;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/GuidebookSectionCrafting.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/GuidebookSectionCrafting.java
index dc3d3fd41..3ad07e202 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/GuidebookSectionCrafting.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/GuidebookSectionCrafting.java
@@ -2,20 +2,26 @@ package net.minecraft.client.gui.guidebook.crafting;
 
 import net.minecraft.client.gui.guidebook.GuidebookPage;
 import net.minecraft.client.gui.guidebook.SearchableGuidebookSection;
-import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCrafting;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.collection.Pair;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.ArrayList;
+import java.util.HashSet;
+import java.util.LinkedHashMap;
 import java.util.List;
+import java.util.Map;
 import java.util.Objects;
+import java.util.Set;
 
 public class GuidebookSectionCrafting
     extends SearchableGuidebookSection {
+
     private final List<GuidebookPage> pages = new ArrayList<>();
     private Pair<String,List<GuidebookPage>> filteredPages = null;
 
@@ -26,8 +32,7 @@ public class GuidebookSectionCrafting
 
     public void reloadRecipes(){
         pages.clear();
-        List<RecipeEntryCrafting<?, ?>> allRecipes = new ArrayList<>(Registries.RECIPES.getAllCraftingRecipes());
-        allRecipes.removeIf((R)->(!RecipePageCrafting.guidebookSupportsRecipe(R)));
+        List<RecipeEntryCrafting<?, ?>> allRecipes = getSupportedRecipes();
         int totalRecipes = allRecipes.size();
         int totalPages = MathHelper.ceilInt(totalRecipes, RecipePageCrafting.RECIPES_PER_PAGE);
         for (int i = 0; i < totalPages; i++) {
@@ -51,10 +56,14 @@ public class GuidebookSectionCrafting
     public List<GuidebookPage> searchPages(SearchQuery query) {
         if(filteredPages == null || !Objects.equals(filteredPages.getLeft(), query.rawQuery)) {
             ArrayList<RecipeEntryCrafting<?, ?>> filteredRecipes = new ArrayList<>();
-            List<RecipeEntryCrafting<?, ?>> allRecipes = new ArrayList<>(Registries.RECIPES.getAllCraftingRecipes());
-            allRecipes.removeIf((R)->(!RecipePageCrafting.guidebookSupportsRecipe(R)));
-            for (RecipeEntryCrafting<?, ?> recipe : allRecipes) {
-                if(recipe.matchesQueryIgnoreExceptions(query)){
+            for (RecipeEntryCrafting<?, ?> recipe : getSupportedRecipes()) {
+                if (recipe instanceof RecipeEntryCraftingGroup group) {
+                    // Lock a consolidated entry to the variants that actually match the query.
+                    RecipeEntryCraftingGroup narrowed = group.filterToQuery(query);
+                    if (narrowed != null) {
+                        filteredRecipes.add(narrowed);
+                    }
+                } else if (recipe.matchesQueryIgnoreExceptions(query)) {
                     filteredRecipes.add(recipe);
                 }
             }
@@ -65,7 +74,7 @@ public class GuidebookSectionCrafting
                 int j = i * RecipePageCrafting.RECIPES_PER_PAGE;
                 ArrayList<RecipeEntryCrafting<?, ?>> recipes = new ArrayList<>(filteredRecipes.subList(Math.min(j, filteredRecipeSize), Math.min(j + RecipePageCrafting.RECIPES_PER_PAGE, filteredRecipeSize)));
                 if (!recipes.isEmpty()) {
-                    filteredPages.add(new RecipePageCrafting(this, recipes));
+                    filteredPages.add(new RecipePageCrafting(this, recipes, query));
                 }
             }
             this.filteredPages = Pair.of(query.rawQuery, filteredPages);
@@ -74,4 +83,33 @@ public class GuidebookSectionCrafting
             return filteredPages.getRight();
         }
     }
+
+    private static @NotNull List<RecipeEntryCrafting<?, ?>> getSupportedRecipes() {
+        List<RecipeEntryCrafting<?, ?>> allRecipes = new ArrayList<>(Registries.RECIPES.getAllCraftingRecipes());
+        allRecipes.removeIf((R) -> (!RecipePageCrafting.guidebookSupportsRecipe(R)));
+        return consolidateGroups(allRecipes);
+    }
+
+    private static @NotNull List<RecipeEntryCrafting<?, ?>> consolidateGroups(@NotNull List<RecipeEntryCrafting<?, ?>> recipes) {
+        Map<String, List<RecipeEntryCrafting<?, ?>>> groups = new LinkedHashMap<>();
+        for (RecipeEntryCrafting<?, ?> recipe : recipes) {
+            if (recipe.consolidationGroup != null) {
+                groups.computeIfAbsent(recipe.consolidationGroup, (k) -> new ArrayList<>()).add(recipe);
+            }
+        }
+
+        List<RecipeEntryCrafting<?, ?>> result = new ArrayList<>();
+        Set<String> emitted = new HashSet<>();
+        for (RecipeEntryCrafting<?, ?> recipe : recipes) {
+            String group = recipe.consolidationGroup;
+            if (group != null && groups.get(group).size() >= 2) {
+                if (emitted.add(group)) {
+                    result.add(new RecipeEntryCraftingGroup(groups.get(group)));
+                }
+                continue;
+            }
+            result.add(recipe);
+        }
+        return result;
+    }
 }
